image: registry.gitlab.com/brinkervii/grapejuice-ci-image/master

stages:
    - test
    - package
    - deploy

grapejuice:quality_control:
    stage: test
    script:
        - export PYTHONPATH=$(pwd)/src
        - python3 -m pip install -r requirements.dev.txt
        - python3 -m pip install -r requirements.txt
        - python3 -m pylint src
        - python3 -m pytest tests

grapejuice:test_local_installation:
    stage: test
    script:
        - ./install.py

grapejuice:linux_package:
    stage: package
    artifacts:
        expire_in: 1 week
        paths:
            - artifacts/
    script:
        - export PYTHONPATH=$(pwd)/src
        - python3 -m pip install -r requirements.dev.txt
        - python3 -m pip install -r requirements.txt
        - python3 -m grapejuice_packaging linux_package --dist-dir artifacts/linux_package
    only:
        - master
        - develop

grapejuice:debian_package:
    stage: package
    artifacts:
        expire_in: 1 week
        paths:
            - artifacts/
    script:
        - export PYTHONPATH=$(pwd)/src
        - python3 -m grapejuice_packaging debian_package --dist-dir artifacts/debian_package
    only:
        - master
        - develop

pages:
    stage: deploy
    artifacts:
        paths:
            - public
    script:
        - pushd ./documentation
        - npm install
        - npm run build
        - popd
        - mkdir public
        - cp -frax ./documentation/public/* ./public
        - bash ./ci_scripts/update_repositories.sh
        - ls -hal public
    only:
        - master
